// DialogSerializeDlg.cpp : implementation file
//

#include "stdafx.h"
#include "DialogSerialize.h"
#include "DialogSerializeDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif

#define DATA_FILE _T("demo.dat")
#include <io.h>

// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	enum { IDD = IDD_ABOUTBOX };

	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support

// Implementation
protected:
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
END_MESSAGE_MAP()


// CDialogSerializeDlg dialog



CDialogSerializeDlg::CDialogSerializeDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CDialogSerializeDlg::IDD, pParent)
{
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CDialogSerializeDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
  DDX_Text(pDX, IDC_EDIT1, m_myFavorites.m_strAcademic);
  DDX_Text(pDX, IDC_EDIT2, m_myFavorites.m_strArtist);
  DDX_Text(pDX, IDC_EDIT3, m_myFavorites.m_strAuthor);
  DDX_Text(pDX, IDC_EDIT7, m_myFavorites.m_strBook);
  DDX_Text(pDX, IDC_EDIT4, m_myFavorites.m_strMovie);
  DDX_Text(pDX, IDC_EDIT5, m_myFavorites.m_strPoet);
  DDX_Text(pDX, IDC_EDIT6, m_myFavorites.m_strScientist);
}

BEGIN_MESSAGE_MAP(CDialogSerializeDlg, CDialog)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	//}}AFX_MSG_MAP
  ON_BN_CLICKED(IDOK, OnBnClickedOk)
END_MESSAGE_MAP()


// CDialogSerializeDlg message handlers

BOOL CDialogSerializeDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon

 if (CanSerialize())
 {
  CFile file;
  CFileException fe;

  if (file.Open(DATA_FILE, 
  CFile::typeBinary | CFile::modeRead, &fe))
  {
   CArchive ar(&file, CArchive::load);
   Serialize(ar);
   UpdateData(FALSE);
  }
 }	

	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CDialogSerializeDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CDialogSerializeDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, reinterpret_cast<WPARAM>(dc.GetSafeHdc()), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this function to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CDialogSerializeDlg::OnQueryDragIcon()
{
	return static_cast<HCURSOR>(m_hIcon);
}

BOOL CDialogSerializeDlg::CanSerialize()
{
 return (0 == _access(DATA_FILE, 6));
}

void CDialogSerializeDlg::Serialize(CArchive& ar)
{
  m_myFavorites.Serialize(ar);

  if (ar.IsStoring())
  {	// storing code
  }
  else
  {	// loading code
  }
}

void CDialogSerializeDlg::OnBnClickedOk()
{
  BOOL bCanSave = FALSE;

  if (UpdateData())
  {
    UINT nFlags = CFile::typeBinary | CFile::modeWrite;

    // File doesnt exist, so create it
    if (_access(DATA_FILE, 0))
    {
      nFlags |= CFile::modeCreate;
      bCanSave = TRUE;
    }
    else
    {
      bCanSave = CanSerialize();
    }

    if (bCanSave)
    {
      CFile file;
      CFileException fe;

      // File exists with read & write permissions
      if (file.Open(DATA_FILE, nFlags, &fe))
      {
        CArchive ar(&file, CArchive::store);
        Serialize(ar);
      }
    }
  }
}
