// FindDlg.cpp : implementation file
//

#include "stdafx.h"
#include "ModelessDemo.h"
#include "FindDlg.h"


// CFindDlg dialog

IMPLEMENT_DYNAMIC(CFindDlg, CIdleDlg)
CFindDlg::CFindDlg(CWnd* pParent)
	: CIdleDlg(CFindDlg::IDD, pParent)
  , m_strFindWhat(_T(""))
  , m_iMatchCase(0)
  , m_iMatchWholeWord(0)
{
}

CFindDlg::~CFindDlg()
{
}

void CFindDlg::DoDataExchange(CDataExchange* pDX)
{
	CIdleDlg::DoDataExchange(pDX);
  DDX_Text(pDX, IDC_EDIT2, m_strFindWhat);
  DDX_Check(pDX, IDC_CHECK1, m_iMatchCase);
  DDX_Check(pDX, IDC_CHECK2, m_iMatchWholeWord);
}


BEGIN_MESSAGE_MAP(CFindDlg, CIdleDlg)
  ON_BN_CLICKED(IDOK, OnBnClickedOk)
  ON_BN_CLICKED(IDCANCEL, OnBnClickedCancel)
END_MESSAGE_MAP()


// CFindDlg message handlers

void CFindDlg::OnBnClickedOk()
{
  if (UpdateData())
  {
    if (0 < m_strFindWhat.GetLength())
    {
      CWnd* pParent = GetParent();
      ASSERT(pParent);
      if (pParent)
      {
        FINDDATA* pfd = new FINDDATA;
        pfd->m_strFindWhat = m_strFindWhat;
        pfd->m_fMatchCase = m_iMatchCase;
        pfd->m_fMatchWholeWord = m_iMatchWholeWord;

        pParent->PostMessage(WM_FINDDATA, 0, (WPARAM)pfd);
      }
    }
    else
    {
      AfxMessageBox("You need to enter the search text.");
    }
  }
}

void CFindDlg::OnBnClickedCancel()
{
  CWnd* pParent = GetParent();
  ASSERT(pParent);
  if (pParent)
  {
    pParent->PostMessage(WM_DIALOGCLOSE, 0, 0);
  }
}
